//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "StrUtils.hpp"
#include "cppMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormKeyPress(TObject *Sender, System::WideChar &Key)
{
    static String sLastDisplay = "";


	//Add digits
	if ((isdigit(Key)) && (lblDisplay->Caption.Length() < 19))
	{
		lblDisplay->Caption += Key;
	}
	//Manage operations
	else if ((Key == '+') || (Key == '-') || (Key == '*') || (Key == '/'))
	{
		sLastDisplay = lblDisplay->Caption;
		lblDisplay->Caption = "";
		lblOperation->Caption = Key;
	}
	//Clear display
	else if (Key == 27)
	{
		lblDisplay->Caption = "";
		lblOperation->Caption = "";
	}
	//Remove last char
	else if ((Key == '\b') && (lblDisplay->Caption.Length() > 0))
	{
		lblDisplay->Caption = LeftStr(lblDisplay->Caption,  lblDisplay->Caption.Length() - 1);
	}
	//Show result
	else if ((Key == '\r') || (Key == '='))
	{
		if (lblOperation->Caption == '+')
		{
			lblDisplay->Caption = StrToInt64(sLastDisplay) + StrToInt64(lblDisplay->Caption);
		}
		else if (lblOperation->Caption == '-')
		{
			lblDisplay->Caption = StrToInt64(sLastDisplay) - StrToInt64(lblDisplay->Caption);
		}
		else if (lblOperation->Caption == '*')
		{
			lblDisplay->Caption = StrToInt64(sLastDisplay) * StrToInt64(lblDisplay->Caption);
		}
		else if (lblOperation->Caption == '/')
		{
			lblDisplay->Caption = StrToInt64(sLastDisplay) / StrToInt64(lblDisplay->Caption);
		}
	}
}
//---------------------------------------------------------------------------
